/*
    mandelbmp - render the Mandelbrot set or Julia sets as BMP files
    Copyright (C) 2022 cas <cas@sdf.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef colormaps_h
#define colormaps_h

#define NAUSEA_R(X) X * X * 255
#define NAUSEA_G(X) sqrt(X) * 255
#define NAUSEA_B(X) (1 - exp(-X))  * 255

#define COLORBLIND_R(X) X * 255
#define COLORBLIND_G(X) X * 255
#define COLORBLIND_B(X) X * 255

#define INVCOLORBLIND_R(X) (1 - X) * 255
#define INVCOLORBLIND_G(X) (1 - X) * 255
#define INVCOLORBLIND_B(X) (1 - X) * 255

#define HERESY_R(X) X * sqrt(X) * 255
#define HERESY_G(X) X * sqrt(X) * 255
#define HERESY_B(X) X * (1 - X) * 255

#define PROPHECY_R(X) (1 - X) * sqrt(1 - X) * 255
#define PROPHECY_G(X) (1 - X) * sqrt(1 - X) * 255
#define PROPHECY_B(X) (1 - X) * X * 255

#define PARASITE_R(X) (1 - X) * sqrt(X) * 255
#define PARASITE_G(X) (1 - X) * sqrt(X) * 255
#define PARASITE_B(X) (1 - X) * X * 255

#define INVADER_R(X) 1 - sqrt(X) * 255
#define INVADER_G(X) .02 * X * 255
#define INVADER_B(X) 1 - sqrt(X) * X * 255

void cmap_get_rgb(int cmap, double v, int* r, int* g, int* b);

#endif
